config/routes.rb
Storehaus::Engine.routes.draw do
  resources :items

  get 'picker' => 'items#index', as: :picker
  get 'cropper/:id' => 'utilities#cropper', as: :cropper
  get 'deliver/:id' => 'utilities#deliver', as: :deliver, defaults: { format: :js }

  root to: 'items#index'
end

app/models/storehaus/application_record.rb
module Storehaus
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/storehaus/item.rb
module Storehaus
  class Item < ApplicationRecord
    paginates_per 30
    belongs_to :blob, class_name: "ActiveStorage::Blob", dependent: :destroy
    delegate :filename, to: :blob

    attribute :library_metadata, LibraryMetadata::Type.new,
              default: LibraryMetadata.new

    def blob_signed_id=(signed_id)
      self.blob = ActiveStorage::Blob.find_signed(signed_id, purpose: :blob_id)
    end

    def self.keyword_search(term)
      return all if term.blank?
      query_string = if connection.adapter_name == "PostgreSQL"
        "EXISTS(SELECT value FROM jsonb_each(library_metadata) WHERE value::varchar ILIKE :term) OR active_storage_blobs.filename ILIKE :term"
      else
        "CAST(library_metadata AS CHAR(2000)) LIKE :term OR active_storage_blobs.filename LIKE :term"
      end
      joins(:blob).where(query_string, term: "%#{term}%")
    end
  end
end

app/models/storehaus/storehaus.rb
module Storehaus
  module Storehaus
    def self.table_name_prefix
      'storehaus_storehaus_'
    end
  end
end

app/controllers/storehaus/application_controller.rb
module Storehaus
  class ApplicationController < ActionController::Base
    layout 'storehaus/application'
    protect_from_forgery with: :exception
    before_action :configured_before_action

    def js_redirect_to(redirect_uri, **options)
      render options.merge(js: "window.location.replace('#{redirect_uri}');")
    end

    def configured_before_action
      action = ::Storehaus.config.before_action
      return unless action

      case action
      when Symbol, String
        public_send action
      else
        action.try(:call)
      end
    end
  end
end

app/controllers/storehaus/items_controller.rb
require_dependency "storehaus/application_controller"

module Storehaus
  class ItemsController < ApplicationController
    def index
      @items = filtered_collection.page(params[:page])
    end

    def show
      @item = scoped_collection.find(params[:id])
    end

    def new
      @item = scoped_collection.new
    end

    def edit
      @item = scoped_collection.find(params[:id])
    end

    def create
      @item = scoped_collection.new(permitted_params)

      respond_to do |format|
        if @item.save
          format.html { redirect_to(action: :edit, id: @item) }
          format.js { js_redirect_to redirect_to(action: :edit, id: @item) }
        else
          format.html { render action: "new" }
          format.js { render js: "alert('Please try again');" }
        end
      end
    end

    def update
      @item = scoped_collection.find(params[:id])
      @item.assign_attributes(permitted_params)

      respond_to do |format|
        if @item.save
          format.html { redirect_to action: :show }
          format.js do
            if params[:save_and_return]
              render template: "storehaus/utilities/deliver", assigns: { blob: @item.blob, transformation: Transformation.new }
            else
              js_redirect_to(new_item_path)
            end
          end
        else
          format.html { render action: "edit" }
          format.js { render js: "alert('Please try again');" }
        end
      end
    end

    def destroy
      @item = scoped_collection.find(params[:id])

      if @item.destroy
        redirect_to action: :index
      else
        render :show
      end
    end

    def metadata_fields
      LibraryMetadata.attribute_types
    end
    helper_method :metadata_fields

    protected

    def permitted_params
      attributes = [:blob_signed_id, library_metadata: metadata_fields.keys]
      @permitted_params ||= params.require(:item).permit(*attributes)
    end

    ##
    # Applies user search and filters to the +scoped_collection+
    def filtered_collection
      scoped_collection.keyword_search(params[:q])
    end

    ##
    # Overridable method for applying access scopes to the +base_collection+.
    # For example, assets owned by a current_user
    def scoped_collection
      base_collection
    end

    ##
    # Broadest collection of records
    def base_collection
      Item.all.includes(:blob)
    end
  end
end

app/controllers/storehaus/utilities_controller.rb
require_dependency "storehaus/application_controller"

module Storehaus
  class UtilitiesController < ApplicationController
    layout 'storehaus/utility'

    def cropper
      find_blob
      build_transformation
    end

    def deliver
      find_blob
      build_transformation
    end

    def transformation_params
      params.slice(:crop).permit(crop: %i[x y w h]).to_h
    end
    helper_method :transformation_params

    private
    def find_blob
      @blob ||= ActiveStorage::Blob.find_signed(params[:id], purpose: :blob_id)
    end

    def build_transformation
      @transformation = Transformation.new(transformation_params)
    end
  end
end

app/helpers/storehaus/application_helper.rb
module Storehaus
  module ApplicationHelper
    def thumbnail_source(attachment, **options)
      return missing_icon unless attachment
      if attachment.image?
        main_app.rails_representation_path(attachment.variant(options))
      elsif attachment.previewable?
        main_app.rails_representation_path(attachment.preview(options))
      else
        no_preview_icon
      end
    end

    def missing_icon
      'storehaus/missing.png'
    end

    def no_preview_icon
      'storehaus/no_preview.png'
    end

    def free_crop_ratios
      [[0, 0], [3, 2], [4, 3], [5, 4], [16, 9], [1, 1]]
    end

    def crop_ratios
      free_crop_ratios.push(locked_ratio).compact.uniq
    end

    def freehand_cropping?
      locked_ratio.blank?
    end

    def initial_ratio
      locked_ratio || [0, 0]
    end

    def locked_ratio 
      params[:ratio].split(',').map(&:to_i) 
    rescue
      nil
    end

    def ratio_label(ratio)
      return "Free" if ratio == [0, 0]
      ratio.join('x')
    end

    def ratio_button(ratio)
      label_tag do
        concat radio_button_tag 'ratio', ratio.join(','), ratio == initial_ratio,
                                onchange: "setCropperRatio(getRatio(this))",
                                disabled: !freehand_cropping?
        concat content_tag :span, ratio_label(ratio)
      end
    end
  end
end

app/views/layouts/storehaus/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Storehaus</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    "storehaus/application", media: "all" %>
  <%= javascript_include_tag "storehaus/application" %>
</head>
<body>
<%= render '/storehaus/shared/header' %>
<div id="main" class="container">
  <%= yield %>
</div>
<%= render '/storehaus/shared/footer' %>

</body>
</html>

app/views/layouts/storehaus/utility.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Storehaus</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    "storehaus/application", media: "all" %>
  <%= javascript_include_tag "storehaus/application" %>
</head>
<body>
<div id="cropper" class="container">
  <%= yield %>
</div>
</body>
</html>

app/views/storehaus/_library_metadata_fields.html.erb
<% metadata_fields.each do |name, attribute| %>
	<div class="col-12 field">
	  <%= f.label name, name.humanize %>
	  <%= f.text_field name %>
	</div>
<% end %>

app/views/storehaus/items/_collection.html.erb
<ul class="item-list">
  <%= render collection: collection, partial: 'item' %>
</ul>
<%= paginate collection %>

app/views/storehaus/items/_form.html.erb
<%= form_for @item, url: item_path(@item), remote: true do |f| %>
  <%= f.fields_for @item.library_metadata do |lmf| %>
  <div class="row">
    <%= render 'storehaus/library_metadata_fields', f: lmf %>
  </div>
  <% end %>
  <%= f.submit "Save and Add",
               class: "btn btn-secondary" %>
  <%= f.submit "Save",
               class: "btn btn-primary text-right", name: "save_and_return" %>
<% end %>

app/views/storehaus/items/_item.html.erb
<li class="item col-3 col-5-md col-12-sm">
  <div class="card">
    <%= link_to deliver_path(item.blob.signed_id, format: :js), remote: true do %>
      <div class="item-image" style="background-image: url('<%= image_url thumbnail_source(item.blob) %>'); background-position: center center; background-size: cover;">
      </div>
    <% end %>
    <div class="item-title">
      <%= link_to "View", item_path(item), class: 'btn btn-hollow' %>
      <%= content_tag :span, item.blob.filename %>
    </span>
  </div>
</li>

app/views/storehaus/items/edit.html.erb
<div class="row">
	<div class="col-8">
		<%= image_tag thumbnail_source(@item.blob) %>
	</div>
	<div class="col-4">
		<%= render 'form' %>
	</div>
</div>

app/views/storehaus/items/index.html.erb
<div class="row">
	<div class="col-12 top-bar">
		<div class="col-6 col-3-sm ">
			<%= link_to "Upload", { action: :new }, class: 'btn btn-primary' %>
		</div>
		<div class="col-6 col-10-sm">
			<%= render 'storehaus/shared/search_form' %>
		</div>
	</div>

	<div id="item-collection" class="col-12 col-10-md col-8-sm">
		<%= render 'collection', collection: @items %>
	</div>
</div>

app/views/storehaus/items/index.js.erb
var container = document.querySelector('#item-collection');
var newContent = '<%= j render('collection', collection: @items) %>';

container.innerHTML = newContent;

app/views/storehaus/items/new.html.erb
<%= form_for @item do |f| %>
  <%= f.file_field :blob_signed_id,
            data: { direct_upload_url: main_app.rails_direct_uploads_url } %>
  <br />
  <br />
  <%= f.submit "Upload" %>
<% end %>

<%= javascript_tag do %>
  let submitButton = document.querySelector("input[type=submit]")
  let fileInput = document.querySelector("input[type=file]")

  submitButton.disabled = true;

  fileInput.addEventListener("change", function() {
    if(this.value) { submitButton.disabled = false }
  })
<% end %>

app/views/storehaus/items/show.html.erb
<div class="row">
  <div class="col-8">
    <%= link_to "Download",
	            main_app.rails_blob_path(@item.blob, disposition: 'attachment'), class: "btn btn-primary" %>

    <%= image_tag thumbnail_source(@item.blob), class: 'preview-img' %>

    <%= link_to "Delete", item_path(@item),
	            method: :delete,
	            data: { confirm: "Are you sure?" }, class: "btn btn-danger" %>
  </div>

  <div class="col-4">

    <%= link_to "Edit", edit_item_path(@item), class: "btn btn-primary" %>

    <%= content_tag :dl do %>
      <%= content_tag :dd, @item.blob.filename %>

      <% @item.library_metadata.attributes.each do |key, value| %>
        <%= content_tag :dd, value %>
      <% end %>
    <% end %>

    <!--
	<% @item.blob.attachments.each do |attachment| %>
	  Attached as <%= attachment.name %>
	  to <%= attachment.record %>
	<% end %>
-->
  </div>
</div>

app/views/storehaus/shared/_header.html.erb
<header class="side-nav container">
  <span class="title">Storehaus</span>
  <nav>
    <ul class="menu">
      <li class="menu-item"><%= link_to 'View All', items_path %></li>
    </uL>
  </nav>
</header>

app/views/storehaus/shared/_search_form.html.erb
<%= form_with url: items_path(format: :js), method: :get, local: false,
             class: 'search-bar', role: 'search', id: 'search' do %>
  <%= search_field_tag :q, '', placeholder: 'Keyword' %>
  <%= submit_tag "Search" %>
<% end %>

app/views/storehaus/utilities/cropper.html.erb
<%= form_with url: deliver_path, method: :get, local: false do |f| %>

  <div class="placement-image">
    <%= content_tag :div, class: 'cropper-wrapper' do %>
      <%= image_tag main_app.rails_blob_path(@blob), id: 'cropper-image' %>
    <% end %>
    <div class="row">
      <div class="col-8">
        <div class="cropper-ratios">
          <% crop_ratios.each do |crop_ratio| %>
            <%= ratio_button crop_ratio %>
          <% end %>
        </div>
        <div class="cropper-buttons">
          <%= link_to "Maximize", '#', onclick: "maximizeCropbox()",
                  class: 'btn btn-hollow' %>
          <% if freehand_cropping? %>
            <%= link_to 'Rotate Box', '#', onclick: 'rotateCropbox()',
                    class: 'btn btn-hollow' %>
          <% end %>
        </div>
      </div>
      <div class='col-4 right'>
        <%= f.hidden_field 'crop[x]', value: @transformation.dig(:crop, :x) %>
        <%= f.hidden_field 'crop[y]', value: @transformation.dig(:crop, :y) %>
        <%= f.hidden_field 'crop[w]', value: @transformation.dig(:crop, :w) %>
        <%= f.hidden_field 'crop[h]', value: @transformation.dig(:crop, :h) %>

        <%= f.submit 'Finished', class: 'button green' %>
      </div>
    </div>
  </div>

<% end %>

app/views/storehaus/utilities/deliver.js.erb
data = {
  blobId: '<%= @blob.signed_id %>',
  transformation: <%= raw @transformation.to_json %>,
  newSrc: '<%= j main_app.rails_representation_path(@blob.variant(@transformation.command)) %>'
}

deliverToParent(data)